/*******************************************************************************/
//  Bernard Lidicky - 2000
//  Hippo Games
//  Life
//  MainFrm.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "Life.h"


#include "MainFrm.h"

#include "AboutDlg.h"
#include "StatsDlg.h"
#include "NastavDlg.h"

//******************************************************************************
IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_PLOVOUCIMENU_KONEC, OnKonec)
	ON_COMMAND(ID_PLOVOUCIMENU_OAPLIKACI, OnOAplikaci)
	ON_COMMAND(ID_PLOVOUCIMENU_RODY, OnPlovoucimenuRody)
	ON_COMMAND(ID_PLOVOUCIMENU_RESET, OnPlovoucimenuReset)
	ON_COMMAND(ID_PLOVOUCIMENU_NASATVENI, OnPlovoucimenuNasatveni)
	ON_COMMAND(ID_PLOVOUCIMENU_VKLADANI_CERVENY, OnPlovoucimenuVkladaniCerveny)
	ON_COMMAND(ID_PLOVOUCIMENU_VKLADANI_MODRY, OnPlovoucimenuVkladaniModry)
	ON_COMMAND(ID_PLOVOUCIMENU_VKLADANI_SKALA, OnPlovoucimenuVkladaniSkala)
	ON_COMMAND(ID_PLOVOUCIMENU_VKLADANI_STROM, OnPlovoucimenuVkladaniStom)
	ON_COMMAND(ID_PLOVOUCIMENU_VKLADANI_VODA, OnPlovoucimenuVkladaniVoda)
	ON_COMMAND(ID_PLOVOUCIMENU_VKLADANI_MAZANI, OnPlovoucimenuVkladaniMazani)
	ON_UPDATE_COMMAND_UI(ID_PLOVOUCIMENU_VKLADANI_CERVENY, OnUpdate)
	ON_COMMAND(ID_PLOVOUCIMENU_SOUBOR_ULOZ, OnPlovoucimenuSouborUloz)
	ON_COMMAND(ID_PLOVOUCIMENU_SOUBOR_NACTI, OnPlovoucimenuSouborNacti)
	ON_COMMAND(ID_PLOVOUCIMENU_VKLADANI_NIC, OnPlovoucimenuVkladaniNic)
	ON_WM_CLOSE()
	ON_UPDATE_COMMAND_UI(ID_PLOVOUCIMENU_VKLADANI_MAZANI, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_PLOVOUCIMENU_VKLADANI_MODRY, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_PLOVOUCIMENU_VKLADANI_SKALA, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_PLOVOUCIMENU_VKLADANI_STROM, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_PLOVOUCIMENU_VKLADANI_VODA, OnUpdate)
	ON_UPDATE_COMMAND_UI(ID_PLOVOUCIMENU_VKLADANI_NIC, OnUpdate)
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_INITED,Init)
END_MESSAGE_MAP()

//******************************************************************************
CMainFrame::CMainFrame()
{
	m_inited = FALSE;

	m_lpDDSPlocha  = NULL;
	m_lpDDSPotvory = NULL;
	m_lpDDSPotBig  = NULL;
	m_lpDDSOkoli   = NULL;

	m_mousesel.x = -1;
	m_mousesel.y = 0;

	m_msRok = 500;
	
	m_p_narozeni   = 3;
	m_p_osamoceni  = 2;
	m_p_premnozeni = 3;
	m_p_r_premn    = 2;
	m_p_r_osam     = 0;

	m_lebenshow = true;

	OnPlovoucimenuVkladaniNic();

	Create(NULL,"Life - Symulation",WS_POPUP|WS_SYSMENU);

	m_icon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(m_icon,TRUE);
	SetIcon(m_icon,FALSE);

	m_cursor = AfxGetApp()->LoadCursor(IDC_SIPKA);
	SetCursor(m_cursor);

	// zapnuti timeru -
	m_uTimerID = SetTimer(1,40,NULL);

	m_fontBig.CreateFont(28,0,0,0,200,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Viking");
	m_fontSmall.CreateFont(20,0,0,0,200,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Viking");
}
//******************************************************************************
CMainFrame::~CMainFrame()
{
//	KillTimer(m_uTimerID);
	if(m_lpDDSPotvory != NULL) {
		m_lpDDSPotvory->Release();
		m_lpDDSPotvory = NULL;
	}
	if(m_lpDDSPotBig != NULL) {
		m_lpDDSPotBig->Release();
		m_lpDDSPotBig = NULL;
	}
	if(m_lpDDSPlocha != NULL) {
		m_lpDDSPlocha->Release();
		m_lpDDSPlocha = NULL;
	}
	if(m_lpDDSOkoli != NULL) {
		m_lpDDSOkoli->Release();
		m_lpDDSOkoli = NULL;
	}
}
//******************************************************************************
void CMainFrame::Init(int parama, int paramb)
{
	ZobrazKurzor(TRUE);
	SetCursor(m_cursor);
	// loadingovani
	m_lpDDSPlocha = DDLoadBitmap(ddraw,"IDB_PLOCHA",640,480,AfxGetApp()->m_hInstance);
	if(m_lpDDSPlocha == NULL) SendMessage(WM_CLOSE);

	m_lpDDSPotvory = DDLoadBitmap(ddraw,"IDB_POTVORY",0,0,AfxGetApp()->m_hInstance);
	if(m_lpDDSPotvory == NULL) SendMessage(WM_CLOSE);
	DDSetColorKey(m_lpDDSPotvory,RGB(255,0,255));

	m_lpDDSPotBig = DDLoadBitmap(ddraw,"IDB_POTBIG",0,0,AfxGetApp()->m_hInstance);
	if(m_lpDDSPotBig == NULL) SendMessage(WM_CLOSE);

	m_lpDDSOkoli = DDLoadBitmap(ddraw,"IDB_OKOLI",0,0,AfxGetApp()->m_hInstance);
	if(m_lpDDSOkoli == NULL) SendMessage(WM_CLOSE);
	DDSetColorKey(m_lpDDSOkoli,RGB(255,0,255));


	m_inited     = TRUE;
	m_pause      = FALSE;
	m_uTimerYear = 0;

	Reset();
}

//******************************************************************************
void CMainFrame::Restore()
{
	m_lpDDSPlocha->Restore();
	DDReLoadBitmap(m_lpDDSPlocha,"IDB_PLOCHA",AfxGetApp()->m_hInstance);

	m_lpDDSPotvory->Restore();
	DDReLoadBitmap(m_lpDDSPotvory,"IDB_POTVORY",AfxGetApp()->m_hInstance);
	DDSetColorKey(m_lpDDSPotvory,RGB(255,0,255));

	m_lpDDSPotBig->Restore();
	DDReLoadBitmap(m_lpDDSPotBig,"IDB_POTBIG",AfxGetApp()->m_hInstance);

	m_lpDDSOkoli->Restore();
	DDReLoadBitmap(m_lpDDSOkoli,"IDB_OKOLI",AfxGetApp()->m_hInstance);
	DDSetColorKey(m_lpDDSOkoli,RGB(255,0,255));

	ddraw.Restore();
}
//******************************************************************************
void CMainFrame::OnPaint() 
{
	CFrameWnd::OnPaint();
	if(m_inited == TRUE) {
		Draw();
		CDC *dc = GetDC();
		BitBlt(dc->m_hDC,0,0,640,480,ddraw.GetBackDC(),0,0,SRCCOPY);
		ReleaseDC(dc);
		ddraw.ReleaseBackDC();
	}
}
//******************************************************************************
void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
//******************************************************************************
void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CFrameWnd::OnLButtonDblClk(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// hrac tuknul do plochy
	if(point.x > 10 && point.x < 470 && point.y > 10 && point.y < 470) {
		NewPlayer((point.x-10)/20,(point.y-10)/20);
		SetCapture();
	}

	// kilknuti na menu
	if(point.x > 480 && point.x < 630 && point.y > 18 && point.y < 67) {
		ddraw.FlipToGDI();
		m_pause = TRUE;
		CMenu menu;
		menu.LoadMenu(IDM_MENU);
		menu.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTBUTTON|TPM_LEFTALIGN,point.x,point.y,this);
		menu.DestroyMenu();
		m_pause = FALSE;
	}

	// klikknuti na stakt
	if(point.x > 480 && point.x < 630 && point.y > 415 && point.y < 465) {
		if(m_uTimerYear == 0) m_uTimerYear = SetTimer(2,m_msRok,NULL);
		else {
			KillTimer(m_uTimerYear);
			m_uTimerYear = 0;
		}
	}

	CFrameWnd::OnLButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CFrameWnd::OnLButtonUp(nFlags, point);
	
	ReleaseCapture();

	// hrac tuknul do plochy
	if(point.x > 10 && point.x < 470 && point.y > 10 && point.y < 470) {
		NewPlayer((point.x-10)/20,(point.y-10)/20);
	}
	
}
//******************************************************************************
void CMainFrame::OnMouseMove(UINT nFlags, CPoint point) 
{
// hrac tuknul do plochy
	if(point.x > 10 && point.x < 470 && point.y > 10 && point.y < 470) {
		if(GetCapture() == this) 
			NewPlayer((point.x-10)/20,(point.y-10)/20);
		m_mousesel.x = (point.x-10)/20;
		m_mousesel.y = (point.y-10)/20;
	}
	else m_mousesel.x = -1;

	CFrameWnd::OnMouseMove(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnTimer(UINT nIDEvent) 
{
	CFrameWnd::OnTimer(nIDEvent);
	if(m_pause == TRUE) return;

	if(nIDEvent == m_uTimerID) 
		if((!IsIconic())&&(m_inited == TRUE)) {
			if(Draw() == TRUE) {
				ddraw.Flip();
			}
		}

	if(nIDEvent == m_uTimerYear) {
		UdelejTah();
	}


}
//******************************************************************************
void CMainFrame::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CFrameWnd::OnKeyUp(nChar, nRepCnt, nFlags);
	// zpracovani
	switch(nChar){
	case VK_ESCAPE : PostMessage(WM_CLOSE); break;
	case VK_SPACE  : UdelejTah(); break;
	}
}
//******************************************************************************
void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if(point.x > 10 && point.x < 470 && point.y > 10 && point.y < 470) {
	}
	CFrameWnd::OnRButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnRButtonUp(UINT nFlags, CPoint point) 
{
	if(point.x > 10 && point.x < 470 && point.y > 10 && point.y < 470) {
	}
	CFrameWnd::OnRButtonUp(nFlags, point);
}
//******************************************************************************
BOOL CMainFrame::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	SetCursor(m_cursor);
	return TRUE;
//	return CFrameWnd::OnSetCursor(pWnd, nHitTest, message);
}
//******************************************************************************
BOOL CMainFrame::Draw()
{
	HRESULT res;
	int i,j;

	// placnuti pozadi
	res = ddraw.m_lpDDSBack->BltFast(0,0,m_lpDDSPlocha,CRect(0,0,640,480),DDBLTFAST_WAIT|DDBLTFAST_NOCOLORKEY);
	if(res == DDERR_SURFACELOST) {
		Restore();
		return FALSE;
	}

	// kresba potvor
	for(i = 0; i < 23; i++)
		for(j = 0; j < 23; j++) {
			if(m_hra[i][j].type == NIC) continue;
			if((m_hra[i][j].type == SMRTKA)&&(m_lebenshow == false)) continue; // test na zobrazovani lebni
			res = ddraw.m_lpDDSBack->BltFast(11+i*20,11+j*20,m_lpDDSPotvory,m_hra[i][j].rect,DDBLTFAST_WAIT|DDBLTFAST_SRCCOLORKEY);
			if(res == DDERR_SURFACELOST) {
				Restore();
				return FALSE;
			}
		}

	// prepsani tlacitka na zastaveni symulace
	if(m_uTimerYear != 0) {
		res = ddraw.m_lpDDSBack->BltFast(482,414,m_lpDDSOkoli,CRect(0,0,149,50),DDBLTFAST_WAIT|DDBLTFAST_NOCOLORKEY);
		if(res == DDERR_SURFACELOST) {
			Restore();
			return FALSE;
		}
	}

	// potreba pro psani textu
	CString  s;
	CDC *dc;
	CFont *p_dc;

	// potvora napravo !!! - ta vybrana mysi
	i = m_mousesel.x;
	j = m_mousesel.y;
	if(i != -1 && m_hra[i][j].type != NIC && (m_lebenshow == true || m_hra[i][j].type != SMRTKA)) {
		res = ddraw.m_lpDDSBack->BltFast(490,192,m_lpDDSPotBig,
			   CRect((m_hra[i][j].rect.left/20)*50,(m_hra[i][j].rect.top/20)*100,(m_hra[i][j].rect.left/20)*50+50,(m_hra[i][j].rect.top/20)*100+100),DDBLTFAST_WAIT|DDBLTFAST_NOCOLORKEY);
		if(res == DDERR_SURFACELOST) {
			Restore();
			return FALSE;
		}

		dc = CDC::FromHandle(ddraw.GetBackDC());
		dc->SetTextColor(RGB(255,255,0));
		dc->SetBkMode(TRANSPARENT);
		p_dc = dc->SelectObject(&m_fontSmall);
		s.Format("%d",m_hra[i][j].lifes);
		dc->DrawText(s,CRect(590,200,620,220),DT_VCENTER|DT_CENTER);
		s.Format("%d",m_hra[i][j].attack);
		dc->DrawText(s,CRect(590,227,620,242),DT_VCENTER|DT_CENTER);
		s.Format("%d",m_hra[i][j].age);
		dc->DrawText(s,CRect(560,275,620,295),DT_VCENTER|DT_CENTER);
		dc->SelectObject(p_dc);
		ddraw.ReleaseBackDC();
	}

	// Nakresleni mece 
	res = ddraw.m_lpDDSBack->BltFast(492 + m_pomer*1.3 - 11,
		  143,m_lpDDSOkoli,CRect(0,50,22,105),DDBLTFAST_WAIT|DDBLTFAST_SRCCOLORKEY);
	if(res == DDERR_SURFACELOST) {
		Restore();
		return FALSE;
	}

	// napsani roku
	dc = CDC::FromHandle(ddraw.GetBackDC());
	dc->SetTextColor(RGB(255,255,0));
	dc->SetBkMode(TRANSPARENT);
	p_dc = dc->SelectObject(&m_fontBig);
	s.Format("ROK %d",m_year);
	dc->DrawText(s,CRect(495,352,620,384),DT_VCENTER|DT_CENTER);
	dc->SelectObject(p_dc);
	ddraw.ReleaseBackDC();

	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
// Funkce pro preziti

//******************************************************************************
void CMainFrame::UdelejTah()
{
	int i,j;

	m_year++;

	// utoky
	for(i = 0; i < 23; i++)
		for(j = 0; j < 23; j++) {

			if(m_hra[i][j].type	== ZED) {
				m_new[i][j] = m_hra[i][j]; 
				m_new[i][j].age++;
			}
			else m_new[i][j].type = NIC;
			// utok se provadi m_hra
			Attack(i,j,i-1,j);
			Attack(i,j,i+1,j);
			Attack(i,j,i,j-1);
			Attack(i,j,i,j+1);
			Attack(i,j,i-1,j-1);
			Attack(i,j,i-1,j+1);
			Attack(i,j,i+1,j+1);
			Attack(i,j,i+1,j-1);
			// rovnou do m_new
			Born(i,j);
		}

	// preziti
	for(i = 0; i < 23; i++)
		for(j = 0; j < 23; j++) {
			Alive(i,j);
		}

		// takhle to vypadalo drive
//	for(i = 0; i < 23; i++)
//		for(j = 0; j < 23; j++) {
//			g = GetSousedu(i,j); // zakladni pravidla
//			m_new[i][j] = NIC;
//			if((m_hra[i][j] <  NIC) && (g >= 2) && (g <= 3)) m_new[i][j] = POTVORA;
//			if((m_hra[i][j] == NIC) && (g == 3)) m_new[i][j] = POTVORA;
//		}

	memcpy(m_hra ,m_new,23*23*sizeof(st_postava));

	// scitani lidu
	m_rod[0].pop = 0;
	m_rod[1].pop = 0;
	for(i = 0; i < 23; i++)
		for(j = 0; j < 23; j++)
			if(m_hra[i][j].type < SMRTKA) m_rod[m_hra[i][j].type].pop++;

	// prepocitani pomeru - nemuze dojit k deleni nulou :)
		m_pomer = 0.90 * m_pomer + 0.10 * (100.0 * (30 * m_rod[1].pop + 1) / (30 * (m_rod[0].pop + m_rod[1].pop) + 2));

}
//******************************************************************************
int CMainFrame::GetSousedu(int x, int y, int type)
{
	int i = 0;
	
	if(x >  0 && m_hra[x-1][y].type == type) i++;
	if(x < 22 && m_hra[x+1][y].type == type) i++;
	if(y >  0 && m_hra[x][y-1].type == type) i++;
	if(y < 22 && m_hra[x][y+1].type == type) i++;
	if(x >  0 && y >  0 && m_hra[x-1][y-1].type == type) i++;
	if(x >  0 && y < 22 && m_hra[x-1][y+1].type == type) i++;
	if(x < 22 && y >  0 && m_hra[x+1][y-1].type == type) i++;
	if(x < 22 && y < 22 && m_hra[x+1][y+1].type == type) i++;

	return i;
}
//******************************************************************************
void CMainFrame::Attack(int x, int y, int i, int j)
{
	if(m_hra[i][j].type > POTVORB || m_hra[x][y].type > POTVORB || i < 0 || j < 0 || i > 22 || j > 22) return;
	if(m_hra[x][y].type != m_hra[i][j].type) {
		m_hra[i][j].lifes -= m_hra[x][y].attack;
	}
}
//******************************************************************************
void CMainFrame::Born(int i, int j)
{
	if((m_hra[i][j].type != NIC) && (m_hra[i][j].type != SMRTKA)) return;

	int pa = GetSousedu(i,j,POTVORA);
	int pb = GetSousedu(i,j,POTVORB);

	if(pa != m_p_narozeni) pa = 0;
	if(pb != m_p_narozeni) pb = 0;

	if(pa == m_p_narozeni && pb == m_p_narozeni) 
		if(Nahoda(2) == 0) pb = 0;
		else pa = 0;

	if((pa > 0) || (pb > 0)) {
		if(pa > pb) m_new[i][j].type = POTVORA;
		else m_new[i][j].type = POTVORB;
		int tp = Nahoda(3);
		m_new[i][j].rect.SetRect(tp*20, m_new[i][j].type*20, tp*20+19, m_new[i][j].type*20+19);
		m_new[i][j].lifes  = Nahoda(tp+3) + tp + 1;
		m_new[i][j].attack = Nahoda(tp+2) + 1;
		m_new[i][j].age = 0;

		m_rod[m_new[i][j].type].popul++;
		m_rod[m_new[i][j].type].born++;
//		TRACE("OLD = %d -> ",m_hra[i][j].type);
//		TRACE("BORN.. tp = %d lf = %d at = %d\n",m_new[i][j].type,m_new[i][j].lifes,m_new[i][j].attack);
	}
}
//******************************************************************************
void CMainFrame::Alive(int i, int j)
{
	if(m_hra[i][j].type > POTVORB) return;
	 
	int osam = m_p_osamoceni - Nahoda(m_p_r_osam);
	int prem = Nahoda(m_p_r_premn) + m_p_premnozeni;

	int g = GetSousedu(i,j,m_hra[i][j].type);
	if( g >=  osam && g <= prem && m_hra[i][j].lifes > 0) {
		m_new[i][j] = m_hra[i][j];
		m_new[i][j].age++;
	}
	else {
		int tp = m_hra[i][j].type;
		m_rod[tp].dead++;
		m_new[i][j].type = SMRTKA;
		m_new[i][j].attack = 0;
		m_new[i][j].lifes  = 0;
		// osamoceni
		if(g < osam) {
			m_new[i][j].rect = CRect(0 ,40,18,58);
			m_rod[tp].deadbyalone++;
		}
		// premnozeni
		else 
			if(g > prem) {
				m_new[i][j].rect = CRect(20,40,38,58);
				m_rod[tp].deadnoeat++;
			}
		     // smrat vrazdou
			else  {
				m_new[i][j].rect = CRect(40,40,58,58);
				m_rod[abs(tp-1)].killed++;
			}
	}
		
}
//******************************************************************************
void CMainFrame::NewPlayer(int i, int j)
{
	if(m_vkladani == VYPNUTO) return;
	if(m_vkladani == CERVENY || m_vkladani == MODRY){
		if(m_hra[i][j].type == m_vkladani) return;
		int type = Nahoda(3);
		m_hra[i][j].type = m_vkladani;
		m_hra[i][j].rect.SetRect(type*20, m_vkladani*20, type*20+19, m_vkladani*20+19);
		m_hra[i][j].lifes  = Nahoda(type+3) + type + 1;
		m_hra[i][j].attack = Nahoda(type+2) + type + 1;
		m_hra[i][j].age    = 0;
		m_rod[m_vkladani].popul++;
	}
	else
		m_hra[i][j] = m_vloz;
}
//******************************************************************************
void CMainFrame::Reset()
{
	int i,j;

	if(m_uTimerYear != 0) { // vypnuti symulace
		KillTimer(m_uTimerYear);
		m_uTimerYear = 0;
	}

	m_year = 0;
	for(i = 0; i < 2; i++){
		m_rod[i].born = 0;
		m_rod[i].dead = 0;
		m_rod[i].deadbyalone = 0;
		m_rod[i].deadnoeat = 0;
		m_rod[i].killed = 0;
		m_rod[i].pop = 0;
		m_rod[i].popul = 0;
	}

	for(i = 0; i < 23; i++)
		for(j = 0; j < 23; j++)
			m_hra[i][j].type = NIC;
		
	m_pomer = 50;
}

//******************************************************************************
// Menu Commands !!!!!!
//******************************************************************************
void CMainFrame::OnKonec() 
{
	PostMessage(WM_CLOSE);
}
//******************************************************************************
void CMainFrame::OnOAplikaci() 
{
	m_pause = TRUE;
	ddraw.FlipToGDI();
	CAboutDlg dlg;
	dlg.DoModal();
	m_pause = FALSE;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuRody() 
{
	m_pause = TRUE;
	ddraw.FlipToGDI();
	CStatsDlg dlg(this);
	dlg.DoModal();
	m_pause = FALSE;
	
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuReset() 
{
	Reset();	
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuNasatveni() 
{
	m_pause = TRUE;
	ddraw.FlipToGDI();
	CNastavDlg dlg(this);
	dlg.DoModal();

	if(m_uTimerYear != 0) {
		KillTimer(m_uTimerYear);
		m_uTimerYear = SetTimer(2,m_msRok,NULL);
	}

	m_pause = FALSE;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuVkladaniCerveny() 
{
	m_vkladani  = CERVENY;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuVkladaniModry() 
{
	m_vkladani  = MODRY;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuVkladaniSkala() 
{
	m_vloz.type = ZED;
	m_vloz.age  = 0;
	m_vloz.attack = 0;
	m_vloz.lifes = 0;
	m_vloz.rect.SetRect(0,60,19,79);
	m_vkladani  = SKALA;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuVkladaniStom() 
{
	m_vloz.type = ZED;
	m_vloz.age  = 0;
	m_vloz.attack = 0;
	m_vloz.lifes = 0;
	m_vloz.rect.SetRect(20,60,39,79);
	m_vkladani  = STROM;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuVkladaniVoda() 
{
	m_vloz.type = ZED;
	m_vloz.age  = 0;
	m_vloz.attack = 0;
	m_vloz.lifes = 0;
	m_vloz.rect.SetRect(40,60,59,79);
	m_vkladani  = VODA;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuVkladaniMazani() 
{
	m_vloz.type = NIC;
	m_vkladani  = MAZANI;
}
//******************************************************************************
void CMainFrame::OnPlovoucimenuVkladaniNic() 
{
	m_vkladani = VYPNUTO;
}
//******************************************************************************
void CMainFrame::OnUpdate(CCmdUI* pCmdUI) 
{
	if(pCmdUI->m_nID == ID_PLOVOUCIMENU_VKLADANI_MODRY ) if (m_vkladani == MODRY)
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
	
	if(pCmdUI->m_nID == ID_PLOVOUCIMENU_VKLADANI_CERVENY) if (m_vkladani == CERVENY)
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);

	if(pCmdUI->m_nID == ID_PLOVOUCIMENU_VKLADANI_STROM ) if ( m_vkladani == STROM)
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);

	if(pCmdUI->m_nID == ID_PLOVOUCIMENU_VKLADANI_VODA ) if ( m_vkladani == VODA)
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);

	if(pCmdUI->m_nID == ID_PLOVOUCIMENU_VKLADANI_SKALA ) if ( m_vkladani == SKALA)
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);

	if(pCmdUI->m_nID == ID_PLOVOUCIMENU_VKLADANI_MAZANI) if (m_vkladani == MAZANI)
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0); 

	if(pCmdUI->m_nID == ID_PLOVOUCIMENU_VKLADANI_NIC) if (m_vkladani == VYPNUTO)
		pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0); 
}


/////////////////////////////////////////////////////////
/*
-------------
--- C/C++ ---
-------------
#define FILE_SIGN  0x00FF00FF
#define FL_TP_NIC    0
#define FL_TP_ZED    1
#define FL_TP_ZIVOT  2

typedef struct {  // sizeof == 90*byte
	long  sign;    // musi byt == FILE_SIGN
	byte  x;       // rozmer x
	byte  y;       // rizmer y
	long  version; // kazdy ma svoji verzi - je rozhodujici pro reserved !!
	long  reserved[20];  // pro vlastni pouziti 
} st_file_header;

typedef struct {  // sizeof == 10*byte
	byte  typ;  // co je na policku
	byte  reserved[9]; // pro vlastni potrebu
} st_file_unit;

--------------
--- PASCAL ---
--------------

const FILE_SIGN   = $00FF00FF;
const FL_TP_NIC   = 0;
const FL_TP_ZED   = 1;
const FL_TP_ZIVOT = 2;

type
   st_file_header = record  {dohromady 90 * byte}
      sign    :  longint;  { musi byt = FILE_SIGN }
      x       :  byte;  { rozmer x }
      y       :  byte;  { rozmer y }
      version :  longint;  { kazdy ma svoji verzi - je rozhodujici pro reserv !! }
      reserv  :  array[1..20] of longint;  { pro vlastni pouziti }
   end;

   st_file_unit = record  {celkem  10 * byte}
	   typ  :  byte;   { co je na policku }
	   res  :  array[1..9] of byte;  { pro vlastni potrebu  }
   end;



--------------
--- SOUBOR ---
--------------

  hlavicka - vzdy a hned na zacatku
  po RADCICH ulozena hraci plocha 	

*/

#define FILE_SIGN  0x00FF00FF
//                    A D E B
#define FILE_MY    0x41444542
#define FL_TP_NIC    0
#define FL_TP_ZED    1
#define FL_TP_ZIVOT  2

typedef struct {  // size == 90*byte
	long  sign;    // musi byt == FILE_SIGN
	byte  x;       // rozmer x
	byte  y;       // rizmer y
	long  version; // kazdy ma svoji verzi - je rozhodujici pro reserved !!
	// vlastni 
	long  year;
	long  reserved[19];  // pro vlastni pouziti 
} st_file_header;

typedef struct { // size == 10*byte
	byte  typ;  // co je na policku
	// vlastni
	byte  co;     // jaky typ toho, co tam je - odpovida  m_hra[i][j].rect.left
	byte  age;    // vek
	byte  hp;     // zivoty postavy
	byte  at;     // utok postavy
	byte  mtype;  // odpovida typu  m_hra[i][j].type
	byte  reserved[3]; // pro vlastni potrebu
} st_file_unit;


/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
// ukladani do souboru //
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void CMainFrame::OnPlovoucimenuSouborUloz() 
{
	m_pause = TRUE;
	ddraw.FlipToGDI();
	CFileDialog dlg(FALSE,"lfe",NULL,OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY ,
		"Life Files (*.lfe)|*.lfe| All Files (*.*)|*.*||");

	CFile f;
	if(dlg.DoModal() == IDOK)

		if(f.Open(dlg.GetPathName(),CFile::modeWrite|CFile::modeCreate|CFile::typeBinary) == TRUE) {

			st_file_header  fh;
			st_file_unit    fu;

			// zapis hlavicky
			fh.sign    = FILE_SIGN;
			fh.x  = 23;
			fh.y  = 23;
			fh.version = FILE_MY;
			// vlastni
			fh.year = m_year;

			f.Write(&fh,sizeof(fh));

			
			////// zapis vlastnich dat
			for(int j = 0; j < 23; j++)
				for(int i = 0; i < 23; i++) {

						switch(m_hra[i][j].type){
						case ZED :
							fu.typ = FL_TP_ZED;
							break;
						case POTVORA :
						case POTVORB :
							fu.typ = FL_TP_ZIVOT;
							break;
						case NIC:
						case SMRTKA:
						default :
							fu.typ = FL_TP_NIC;
						}

						fu.age = m_hra[i][j].age;
						fu.at  = m_hra[i][j].attack;
						fu.hp  = m_hra[i][j].lifes;

						fu.co    = m_hra[i][j].rect.left;
						fu.mtype = m_hra[i][j].type;

					f.Write(&fu,sizeof(fu));
				}

		f.Close();
	}
	m_pause = FALSE;
}

/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
// nacitani ze souboru //
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnPlovoucimenuSouborNacti() 
{
	int i,j;

	m_pause = TRUE;
	ddraw.FlipToGDI();
	CFileDialog dlg(TRUE,"lfe",NULL,OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY ,
		"Life Files (*.lfe)|*.lfe| All Files (*.*)|*.*||");
	if(dlg.DoModal() == IDOK) {
		CFile f;
		if(f.Open(dlg.GetPathName(),CFile::modeRead|CFile::typeBinary) == TRUE) {

			st_file_header  fh;
			st_file_unit    fu;
			bool            myfile = false;

			// zpracovani hlavicky
			f.Read(&fh,sizeof(fh));

			// test na spravny soubor
			if(fh.sign != FILE_SIGN) {
				m_pause = FALSE;
				return;
			}

			Reset();
		
			if(fh.version == FILE_MY) myfile = true;
			else myfile = false;

			if(myfile) {
				m_year = fh.year;
			}

			////// cteni vlastnich dat
			for(j = 0; j < fh.y; j++)
				for(i = 0; i < fh.y; i++) {
					f.Read(&fu,sizeof(fu));
					if(i > 23 || j > 23) continue; // dalsi se proste ignoruji

					if(myfile) { // je-li to muj soubor
						m_hra[i][j].age    = fu.age;
						m_hra[i][j].attack = fu.at;
						m_hra[i][j].lifes  = fu.hp;

						m_hra[i][j].type = fu.mtype;
						m_hra[i][j].rect.SetRect(fu.co, fu.mtype*20, fu.co+19, fu.mtype*20+19);
					}
					else  // tohle nei muj soubor
						switch(fu.typ) {
						case FL_TP_ZIVOT :
							m_hra[i][j].type = POTVORA;
							m_hra[i][j].age    = 0;
							m_hra[i][j].attack = 2;
							m_hra[i][j].lifes  = 2;
							m_hra[i][j].rect.SetRect(0, 0, 19, 19);
							break;
						case FL_TP_ZED :
							m_hra[i][j].type = ZED;
							m_hra[i][j].age    = 0;
							m_hra[i][j].attack = 0;
							m_hra[i][j].lifes  = 0;
							m_hra[i][j].rect.SetRect(0, 60, 19, 79);
							break;
						case FL_TP_NIC :
						default:
							m_hra[i][j].type = NIC;
						}
				}

			// vypnuti timeru
			if(m_uTimerYear != 0) {
				KillTimer(m_uTimerYear);
				m_uTimerYear = 0;
			}
			m_vkladani = VYPNUTO;
			// scitani lidu
			m_rod[0].pop = 0;
			m_rod[1].pop = 0;
			for(i = 0; i < 23; i++)
				for(j = 0; j < 23; j++)
					if(m_hra[i][j].type < SMRTKA) m_rod[m_hra[i][j].type].pop++;

			// prepocitani pomeru
				m_pomer = 100.0 * (30 * m_rod[1].pop + 1) / (30 * (m_rod[0].pop + m_rod[1].pop) + 2);


			f.Close();
		}
	}
	m_pause = FALSE;
}
