/*******************************************************************************/
//  Bernard Lidicky - 2000
//  Life
//  CMainFrame class - Include
/*******************************************************************************/

#if !defined(AFX_MAINFRM_H__27D373A8_414E_11D3_8F74_BFB7B0ECBC5C__INCLUDED_)
#define AFX_MAINFRM_H__27D373A8_414E_11D3_8F74_BFB7B0ECBC5C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// herni definy

// zalezi na IDB_POTVORY
#define POTVORA  0
#define POTVORB  1
#define SMRTKA   2
#define ZED      3
#define NIC      4

// vkladani
#define MODRY    0
#define CERVENY  1
#define SKALA    2
#define VODA     3
#define STROM    4
#define MAZANI   5
#define VYPNUTO  6

//////////////////////////////////
/// structures

typedef struct {
	int   lifes;
	int   attack;
	int   type;
	int   age; 
	CRect rect;
} st_postava;


typedef struct{
	int  killed;      // kolik zabili nepratel
	int  popul;       // kolik meli uplne celkem lidicek
	int  dead;        // celkem umrelo
	int  deadbyalone; // umrelo v osameni
	int  deadnoeat;   // umrelo na premnozeni
	int  born;        // kolik se nakodilo

	int  pop;			// pouze aktualni generace
} st_statist;


/////////////////////////////////////////////////////////////////////////////
// CMainFrame dialog

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();

protected: 
	DECLARE_DYNAMIC(CMainFrame)

	UINT	 m_uTimerID;
	UINT   m_uTimerYear;

public :
	int	m_msRok;
	int	m_p_narozeni;
	int	m_p_osamoceni;
	int	m_p_premnozeni;
	int	m_p_r_premn;
	int	m_p_r_osam;

public:
	virtual ~CMainFrame();

	// grafika
	BOOL Draw();  // prekresli celou plochu
	void Init(int parama, int paramb); // necte bitmpy atd..
	void Restore(); // reinicializuje bitmapy

	LPDIRECTDRAWSURFACE  m_lpDDSPlocha;
	LPDIRECTDRAWSURFACE  m_lpDDSPotvory; // potvory v malem
	LPDIRECTDRAWSURFACE  m_lpDDSPotBig;  // potvory ve velkem
	LPDIRECTDRAWSURFACE  m_lpDDSOkoli;   // ruzny blbosti

	HICON   m_icon;
	HCURSOR m_cursor;
	bool    m_lebenshow; // urcuje, zda se maji zobrazovat lebky

	// pouziva se font Viking
	CFont m_fontSmall;
	CFont m_fontBig;


	BOOL m_inited; // zda byla grafika iniciaizovana
	BOOL m_pause;  // menu ap.

	CPoint     m_mousesel; // ktera potvora se mozbrazovat vpravo
	int        m_vkladani;
	st_postava m_vloz;

	// vlastni hra - tahy atd..
	void Reset();  // vynuluje vsechny udaje
	void UdelejTah();  // udela dalsi generaci
	void Alive(int i, int j);
	void Born(int i, int j);
	void Attack(int x, int y, int i, int j);  // provede utoky
	int  GetSousedu(int x, int y, int type);
	void NewPlayer(int i, int j);

	st_postava  m_hra[23][23]; // plocha hry
	st_postava  m_new[23][23]; // mezicast - pri tvorbe nove generace

	int         m_year;   // jaky je rok (pocet kol)
	st_statist  m_rod[2]; // mame dva rody
	double      m_pomer;  // kdo z rodu je na tom lepe  0 - 100 pro cervene

protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg void OnPaint();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKonec();
	afx_msg void OnOAplikaci();
	afx_msg void OnPlovoucimenuRody();
	afx_msg void OnPlovoucimenuReset();
	afx_msg void OnPlovoucimenuNasatveni();
	afx_msg void OnPlovoucimenuVkladaniCerveny();
	afx_msg void OnPlovoucimenuVkladaniModry();
	afx_msg void OnPlovoucimenuVkladaniSkala();
	afx_msg void OnPlovoucimenuVkladaniStom();
	afx_msg void OnPlovoucimenuVkladaniVoda();
	afx_msg void OnPlovoucimenuVkladaniMazani();
	afx_msg void OnUpdate(CCmdUI* pCmdUI);
	afx_msg void OnPlovoucimenuSouborUloz();
	afx_msg void OnPlovoucimenuSouborNacti();
	afx_msg void OnPlovoucimenuVkladaniNic();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_MAINFRM_H__27D373A8_414E_11D3_8F74_BFB7B0ECBC5C__INCLUDED_)
