// Hippo Direct Draw Class
// pokud vam nejaka cast nevyhovuje, muzete si ji sami upravit k obrazu svemu

#ifndef HDDRAW_HEADER
#define HDDRAW_HEADER

// using  640*480* !16!

#include <ddraw.h>   // pro jistotu
#include "ddutils.h" // to se hodi

// using DirectDraw 5  - nemam doma DX7.00 - dll knihovny
class HDDraw
{
public:
	HDDraw();
	HDDraw(HWND hWnd, DWORD Width, DWORD Height, DWORD Color = 0);
	~HDDraw();

   // Alpha blitting - poze 16. bitove - SORRY
	HRESULT InitAlpha(DDPIXELFORMAT& r_pixelFormat); 

	HRESULT FadeBlock  (LPDIRECTDRAWSURFACE lpdest, int destX, int destY, int width, int height);
	HRESULT AlphaBlt   (LPDIRECTDRAWSURFACE lpdest, int destX, int destY, LPDIRECTDRAWSURFACE lpsrc, RECT * p_rect, byte alpha);
	HRESULT AlphaBltEx (LPDIRECTDRAWSURFACE lpdest, int destX, int destY, LPDIRECTDRAWSURFACE lpsrc, RECT * p_rect, HBITMAP halpha);

	HRESULT FadeBlockC  (DDSURFACEDESC& r_destSurface, int destX, int destY, int width, int height);
	HRESULT AlphaBltC   (DDSURFACEDESC& r_destSurface, int destX, int destY, DDSURFACEDESC& r_srcSurface, RECT * p_srcRect, byte alpha);
   HRESULT AlphaBltExC (DDSURFACEDESC& r_destSurface, int destX, int destY, DDSURFACEDESC& r_srcSurface, RECT * p_srcRect, DDSURFACEDESC& r_alphaSurface);
	
private:
	unsigned int m_rMask;
	unsigned int m_gMask;
	unsigned int m_bMask;
	unsigned int m_FadeMask;

public:

	// operatory
	operator LPDIRECTDRAW();

	BOOL CreateFullScreen(HWND hWnd, DWORD Width, DWORD Height, DWORD FillColor = 0);

	void Fill   (DWORD FillColor);
	void FillGDI(DWORD FillColor);

	void Restore();

	HRESULT Flip(BOOL VSync=TRUE);


	void InitHDDraw();

	void FadeToBlack(WORD duration);
	void FadeToSource(WORD duration);

public:
	void ReleaseBackDC();
	HDC GetBackDC();
	
	void ReleaseGDIDC();
	HDC GetGDIDC();

	HRESULT FlipToGDI();

	LPDIRECTDRAW m_lpDD;   // hlavni objekt
	LPDIRECTDRAWSURFACE m_lpDDSGDI;
	LPDIRECTDRAWSURFACE m_lpDDSBack;

	HDC  m_dcBack;
	HDC  m_dcGDI;

	BOOL m_bFullScreen; // je ve FullScreen modu ? 						
	BOOL m_GDIVisible;  // zda je zobrazen GDI surface
	BOOL m_FlipLock;    // zakaze flipping - misto toho se pouziva jednoduse kopirovani

	RECT m_Rect;  // ma v sobe rozmery obrazovky
};

#endif
